<?php

include '../core.php';

session_start();

cabecera (1);

// Controles ActiveX de microsoft que contienen la libreria de enlace dinamico
// XEnroll.dll encargada de generar la clave privada. Tambien se incluye el 
// script vbs que contiene las funciones encargadas de manejar la libreria 
// XEnroll.dll. Una de ellas es enumCSP(), la cual muestra un listado con todos
// los proveedores criptograficos. 
echo "<!-- Use the Microsoft ActiveX control to install the certificate -->
  <object
    classid='clsid:43f8f289-7a20-11d0-8f06-00c04fc295e1'
    codebase='/xenroll.dll'
    id=certHelperOld>
  </object>
  <object
    classid='clsid:127698e4-e730-4e5c-a2b1-21490a70c8a1'
    codebase='/xenroll.dll'
    id=certHelperNew>
  </object>

  <script type='text/vbscript' src='ie/ieCSR.vbs'></script>

  <body onload='enumCSP()'>";


// El siguiente script se encarga de comprobar que los datos 
// de un formulario son validos antes de enviaros 

echo "<script type='text/javascript'>
<!--
function submit_form()
{
  if ( document.csr_form.csr_ID_name.value == '' ||
       document.csr_form.csr_ID_name.value.search(/[^a-z,A-Z,0-9,\.,_,\-]/i) >= 0 ||
       document.csr_form.csr_ID_name.value == 'nombre.apellido' )
  {
    alert ('Por favor introduzca un Identificador correcto. Solo puede escribir caracteres de la \'a\' a la \'z\', 	números y signos \'.\', \'-\' y \'_\'');
    document.csr_form.csr_ID_name.focus();
    return false;
  } 
  if (document.csr_form.csr_cn.value == '')
  {
    alert ('Por favor introduzca su nombre');
    document.csr_form.csr_cn.focus();
    return false;
  }
  if (document.csr_form.csr_sn.value == '')
  {
    alert ('Por favor introduzca su apellido');
    document.csr_form.csr_sn.focus();
    return false;
  }
  if (document.csr_form.csr_telf.value == '')
  {
    alert ('Por favor introduzca su teléfono de contacto');
    document.csr_form.csr_telf.focus();
    return false;
  }
  if ( document.csr_form.csr_mail.value == '' ||
       document.csr_form.csr_mail.value.indexOf('@') == -1 ||
       document.csr_form.csr_mail.value.indexOf('.') == -1)
  {
    alert ('Por favor introduzca su dirección de correo electrónico');
    document.csr_form.csr_mail.focus();
    return false;
  }
  if (document.csr_form.csr_pass.value == '' || document.csr_form.csr_pass2.value == '')
  {
    alert ('Por favor introduzca las dos claves');
    document.csr_form.csr_pass.focus();
    return false;
  }
  if (document.csr_form.csr_pass.value != document.csr_form.csr_pass2.value)
  {
    alert ('Las dos claves no coinciden');
    document.csr_form.csr_pass.focus();
    return false;
  }
						    
  
  if (document.csr_form.csr_pw1.value == '' || document.csr_form.csr_pw2.value == '')
  {
    alert ('Por favor introduzca los dos PINes');
    document.csr_form.csr_pw1.focus();
    return false;
  }
  if (document.csr_form.csr_pw1.value != document.csr_form.csr_pw2.value)
  {
    alert ('Los dos PINes no coinciden');
    document.csr_form.csr_pw1.focus();
    return false;
  }
  document.csr_form.submit();
  return true;
}

function removeNameSubname() {
   document.csr_form.csr_ID_name.value='';
   return true;
}				     
// -->
</script>\n";

// En esta variable guardaremos el estado de la solicitud 
// (rellenandose, verificandose o enviandose). Dependiendo de
// su valor, entraremos en una u otra parte del codigo
$command = $_POST ["csr_command"];
$csrtype = $_GET ["type"];
$status = "new";
$copa = "abc";

switch ( $command ) {

  default:  // Por defecto se muestra un formulario 
	    // para que lo rellene el usuario
   if (isset ($invalid_id) && $invalid_id='true') {
      echo "<h1>Error enviando los datos</h1>
      <p>El identificador que ha introducido no es v&aacute;lido. Por favor, introduzca uno diferente.</p>";
      $errorNumber = 69;
   }

   if ($csrtype == "usr") {
        
	echo "<h1 class='title'>Solicitud de Certificado de Usuario</h1>
	<form method='post' action='csr_ie.php?type=usr' enctype='multipart/form-data' name='csr_form'>
	<p>Autoridad de Registro: <b>$raName</b></p>
	  <table class='box' border='0' cellpadding='1' cellspacing='1'>
	  <tr>
	    <td><a href='help.php#identificador'>Identificador</a></td>
	    <td><input class='form_input' type='text' name='csr_ID_name'  size='25' minlen='7' value='nombre.apellido' onfocus='removeNameSubname()'/> <b> @</b>
              <select name='domain'>";
              while (list ($index) = each ($raDomains)) 
     	        echo "<option>$index</option>";
	          
	      echo "</select>
	    </td> 
	  </tr>
	  <tr>
	    <td>Nombre</td>
	    <td><input class='cajaTexto' type='text' name='csr_cn'  value='$csr_cn' size='30' /></td>
	  </tr>
	  <tr>
	    <td>Apellidos</td>
	    <td><input class='cajaTexto' type='text' name='csr_sn'  value='$csr_sn' size='40' /></td>
	  </tr>
	  <tr>
	    <td><a href='help.php#clave_usuario'>Clave de Usuario</a></td>
	    <td><input class='cajaTexto' type='password' name='csr_pass'  size='20' /></td>
	  </tr>
	  <tr>
            <td>Repita la clave</td>
            <td><input class='cajaTexto' type='password' name='csr_pass2'  size='20' /></td>
          </tr>
	  <tr>
	    <td>Teléfono</td>
	    <td><input class='cajaTexto' type='text' name='csr_telf'  value='$csr_telf' size='20' /></td>
	  </tr>
	  <tr>
	    <td>email</td>
	    <td><input class='cajaTexto' type='text' name='csr_mail'  value='$csr_mail' size='30' /></td>
	  </tr>
	  <tr>
	    <td>PIN</td>
	    <td><input class='cajaTexto' type='password' name='csr_pw1'  size='16' /></td>
	  </tr>
	  <tr>
	    <td>Repita PIN</td>
	    <td><input class='cajaTexto' type='password' name='csr_pw2'  size='16' /></td>
	  </tr>
	  <tr>
	    <td><br>Privacidad </td>
	    <td><br> ¿Desea <a href=help.php#show_mail'>incluir su email en el certificado</a>?
		 <input type='radio' name='csr_showMail'  value='FALSE' checked> No
		 <input type='radio' name='csr_showMail'  value='TRUE'> Si
	    </td>
	  </tr>
	  </table>
	  <input type='hidden' name='csr_command'      value='csr_ie_vrf' />
	  <p><input type='button' value='Continuar' onclick='submit_form()' /></p> 
	</form>
	";		
     }

     else{
   
        echo "<h1 class='title'>Solicitud de Certificado de Servidor</h1>
	<form method='post' action='csr_ie.php?type=srv' enctype='multipart/form-data' name='csr_form'>
	<p>Autoridad de Registro: <b>$raName</b></p>
	  <table class='box' border='0' cellpadding='1' cellspacing='1'>
	  <tr>
	  <td><a href='help.php#identificador'>Identificador</a></td>
	    <td><input class='form_input' type='text' name='csr_service'  size='8' /> /
	      <input class='form_input' type='text' name='csr_ID_name'  size='17' /> .
	      <select name='domain'>";
              while (list ($index) = each ($raDomains)) 
                 echo "<option>$index</option>";
               
              echo "</select>
	    </td>
	  </tr>
	  <tr><td colspan='2'><h4>Datos del Responsable</h4></td></tr>
	  <tr>
	    <td>Nombre</td>
	    <td><input class='cajaTexto' type='text' name='csr_cn'  value='$csr_cn' size='30' /></td>
	  </tr>
	  <tr>
	    <td>Apellidos</td>
	    <td><input class='cajaTexto' type='text' name='csr_sn'  value='$csr_sn' size='40' /></td>
	  </tr>
	  <tr>
 	    <td><a href='help.php#clave_usuario'>Clave de Usuario</a></td>  
  	    <td><input class='cajaTexto' type='password' name='csr_pass'  size='20' /></td>
	  </tr>
	  <tr>
            <td>Repita la clave</td>
            <td><input class='cajaTexto' type='password' name='csr_pass2'  size='20' /></td>
          </tr>
	  <tr>
	    <td>Teléfono</td>
	    <td><input class='cajaTexto' type='text' name='csr_telf'  value='$csr_telf' size='20' /></td>
	  </tr>
	  <tr>
	    <td>email</td>
	    <td><input class='cajaTexto' type='text' name='csr_mail'  value='$csr_mail' size='30' /></td>
 	  </tr>
	  <tr>
	    <td>PIN</td>
	    <td><input class='cajaTexto' type='password' name='csr_pw1'  size='16' /></td>
	  </tr>
	  <tr>
	    <td>Repite PIN</td>
	    <td><input class='cajaTexto' type='password' name='csr_pw2'  size='16' /></td>
	  </tr>
	  </table>
	<input type='hidden' name='csr_command'      value='csr_ie_vrf' />
        <p><input type='button' value='Continuar' onclick='submit_form()' /></p>
        </form>
	";

     }
     
	break;

   case "csr_ie_vrf": // Una vez rellenado, se muestran los datos del 
                      // formulario para que el usuario los oerifique
			 
        // Antes de nada, tendremos que comprobar que el identificador
        // introducido por el usuario sea valido, es decir, que cumpla la
        // expresion regular definida en el archivo de configuracion de la RA
        $regexp = $raDomains[$domain]["validDomainRegexp"];

        // Si no la cumple, devolvemos al usuario al apartado anterior para que
        // introduzca otro identificador
        if (!ereg($regexp,$csr_ID_name)) {
           echo "<form method='post' action='csr_ie.php?type=$csrtype' enctype='multipart/form-data' name='invalid_id_form'>
	   <input type='hidden' name='csr_cn'       value='$csr_cn' />
	   <input type='hidden' name='csr_sn'       value='$csr_sn' />
	   <input type='hidden' name='csr_telf'     value='$csr_telf' />
	   <input type='hidden' name='csr_mail'     value='$csr_mail' />
	   <input type='hidden' name='invalid_id'   value='true' />
	   <input type='hidden' name='csr_command' value='' />

           <script type='text/javascript'>document.invalid_id_form.submit();</script>";
        }

        // Si la cumple, seguiremos adelante
        else{			   
           if ($csrtype == "usr" ){
	      $csr_ID = $csr_ID_name . "@" . $domain;
	      $dn = $baseCrt . $raDomains[$domain]["domain"] . "cn=" . $csr_ID_name;
	   }
	   else {
 	      // Si es una csr de un servicio, le anyadimos su identificador al principio del 
	      // identificador de la solicitud 
	      if ( isset($csr_service) && $csr_service!='')
	         $csr_ID = $csr_service . "/" . $csr_ID_name . "." . $domain;
	      else
	         $csr_ID = $csr_ID_name . "." . $domain;

              $dn = $baseCrt . $raDomains[$domain]["domain"] . "cn=" . $csr_ID;
	   }

	   echo "<h1 class='title'>Detalles de la Solicitud </h1>
	   Subject DN: <b>$dn</b>

	   <pre>
	   <table border='0' cellpadding='2' cellspacing='0'>
	   <tr><td class='csr_edit_name'>Identificador</td>
    	   <td class='csr_edit_value'><b>$csr_ID</b></td></tr>
	   <tr><td class='csr_edit_name'>Nombre</td>
	       <td class='csr_edit_value'><b>$csr_cn $csr_sn</b></td></tr>
	   <tr><td class='csr_edit_name'>Mail</td>
	       <td class='csr_edit_value'><b>$csr_mail</b></td></tr>
	   <tr><td class='csr_edit_name'>Tel&eacute;fono</td>
	       <td class='csr_edit_value'><b>$csr_telf</b></td></tr>
	   </table>
	   </pre>

	   <h3>Proveedor Criptogr&aacute;fico<br><br></h3>

	   <form method='post' action='csr_ie.php' enctype='multipart/form-data' name='pkIRIS'>
             <select name='csp' size='1' id='csp'>
               <option value='' selected>Default</option>
             </select>				    
	     <input type='hidden' name='request'      value='' />
	     <input type='hidden' name='csr_type_nav' value='ie' />
	     <input type='hidden' name='csr_type'     value='$csrtype' />
	     <input type='hidden' name='csr_pass'     value='$csr_pass' />
	     <input type='hidden' name='csr_pw1'      value='$csr_pw1' />
	     <input type='hidden' name='csr_pw2'      value='$csr_pw2' />
	     <input type='hidden' name='csr_ID'       value='$csr_ID' />
	     <input type='hidden' name='csr_cn'       value='$csr_cn' />
	     <input type='hidden' name='csr_sn'       value='$csr_sn' />
	     <input type='hidden' name='csr_telf'     value='$csr_telf' />
	     <input type='hidden' name='csr_mail'     value='$csr_mail' />
	     <input type='hidden' name='subjectDN'    value='$dn' />
	     <input type='hidden' name='csr_showMail' value='$csr_showMail' />
	     <input type='hidden' name='csr_command'  value='csr_add' />
	     <input type='button' value='Continuar'   onclick='GenReq()'>
	   </form>\n";
        } 
	break;

   case "csr_add": // Despues de comprobar los datos, se envia la solicitud a la Ra
	// Hacemos esto para quitar los saltos de linea y que el openssl no de 
	// error a la hora de firmar la CSR
	echo "<h1 class='title'>Solicitud de Certificado</h1>";
	$cn = strtolower($csr_ID);
	
	$filter = "(&(objectclass=pkirisAuthority)(pkirisCopaID=$raNum))";
        $justthese = array ("count");
        $errorNumber = 0; // En esta variable guardaremos el codigo de error (si se produce)
        $errorCounter = 0;
        $result = ldap_get_info($base, $filter, $justthese);

	// Comprobamos que existe la RA en el ldap
        if ($result["count"] != 0) {

           $filter = "(&(objectclass=pkirisEndEntity)(pkirisID=$csr_ID))";
           $result = ldap_get_info($base, $filter, $justthese);
	   
	   //Si es el primer certificados que solicita el usuario
           if ($result["count"] == 0) {
		
	      // Miramos el contador de la Ra para saber la cantidad de usuarios que hay
	      // Con este numero y el de la Ra formaremos el codigo copa
              $numUsr = getCounter ($raNum) + 1;
	      $copaUsr = $raNum . "b" . $numUsr;
	      $copa = $raNum . "b" . $numUsr . "c1";

	      // Preparamos los datos de usuario
	      $info["objectClass"][0]="top";
	      $info["objectClass"][1]="irisObject";
	      $info["objectClass"][2]="pkirisEndEntity";
	      $info["objectClass"][3]="irisPerson";
	      $info[$rdn1]=$copaUsr;
	      $info["pkirisID"]=$csr_ID;
	      $info["sn"]=$csr_sn;
	      $info["cn"]=$csr_cn;
	      $info["telephoneNumber"]=$csr_telf;
	      $info["mail"]=$csr_mail;
	      $info["pkirisCopaID"]=$copaUsr;
      	      $info["pkirisCounter"]="0";
	      $info["userPassword"]="{crypt}".crypt($csr_pass);
      	      #$info["irisUserEntitlement"]="urn:mace:rediris.es:entitlement:pkiris:$raUrl:user";
      	      $info["irisUserEntitlement"]=$pkiris{urnEntitlementPrefix}."$raUrl:user";
	      
               
	      // Guardamos la informacion del ususario que hace la CSR
	      $r=ldap_add_info($rdn1."=".$copaUsr.",".$base, $info);	

	      if (!$r){
	         $errorNumber = 69;
		 $errorCounter ++;
	      }
	     
	      if ($errorCounter == 0) {
  	         // Incrementamos el contador de usuarios de la Ra correspondiente
	         $r = incrCounter($raNum);
	      
	         if (!$r){		
                    $errorNumber = 69;
		    $errorCounter ++;
	         }
	      }	 
	   }
       	   // Si el usuario ha solicitado otro certificado anteriormente
	   else {
			   
	      // Buscamos el pkiId del usuario	      
	      $filter = "(&(objectclass=pkirisEndEntity)(pkirisID=$csr_ID))";
	      $justthese = array ("pkiriscopaid");
	      $idUser = ldap_get_info($base, $filter, $justthese);

	      // Contamos cuantos CRS ha pedido este usuario para formar el codigo copa    
	      $copaUsr = $idUser[0]["pkiriscopaid"][0];	
	      $certCount = getCounter ($copaUsr) + 1;
	      
	      // Comprobamos si el usuario tiene otros certificados firmados o pendientes de ser firmados
	      for ($i = 1; $i < $certCount; $i++){
		 $copa = $copaUsr. "c" . $i;
  	         $lastStatus = getStatus ($copa);
		 
		 if ($lastStatus == "issued") {
		    echo ("<p>El usuario ya tiene un certificado firmado. No puede solicitar uno nuevo.<p>");
                    $errorNumber = 69;
                    $errorCounter ++;
		 }
		 else if ($lastStatus == "new" || $lastStatus == "ra2ca" || $lastStatus == "approved" || $lastStatus == "revoke") {
		    echo ("<p>El usuario ya tiene una solicitud de certificado pendiente de ser procesada. <p>");
                    $errorNumber = 69;
                    $errorCounter ++;  
	         }
	      }
			 
	      $copa = $copaUsr . "c" . $certCount;
           }
        }
        else {
	   $errorNumber = 69;
           $errorCounter ++;
        }	      

	if ( $errorCounter == 0 ) {
           // Preparamos los datos necesarios para generar la traza
           $currentDate = date("YmdHis");
           $dn = $rdn1."=".$copa.",".$base;

	   $traceVals["status"] = $status;
           $traceVals["copa"] = $copa;
           $traceVals["currentDate"] = $currentDate;

           // Generamos la traza con los valores de $traceVals
           $pkiTrace = getTrace($traceVals);

	   // Preparamos los datos que se escribiran en el ldap
	   $info1["objectClass"][0]="top";
	   $info1["objectClass"][1]="irisObject";
	   $info1["objectClass"][2]="pkirisCertificate";
	   $info1[$rdn1]="$copa";
	   $info1["pkirisID"]="$csr_ID";
	   $info1["pkirisTrace"]=$pkiTrace;
	   $info1["pkirisStatus"]=$status;
	   $info1["pkirisDate"]=$currentDate;
	   $info1["pkirisPin"]=crypt($csr_pw1);
	   $info1["pkirisCSR"]="-----BEGIN CERTIFICATE REQUEST-----\n". $request ."-----END CERTIFICATE REQUEST-----";
   	   $info1["pkirisCertType"]="$csr_type";
	   $info1["pkirisSubjectDN"]="$subjectDN";
	   $info1["pkirisCopaID"]="$copa";
           $info1["mail"] = $csr_mail;

           // Si la CSR es de usuario, solo mostraremos el mail en el
           // certificado si el usuario lo autoriza
           if( ($csr_type == "usr") )
              $info1["pkirisshowmail"] = $csr_showMail;
	   // En las de tipo servidor nunca se mostrara el mail
	   else
	      $info1["pkirisshowmail"] = "FALSE";
	   
/*           // Si la CSR es de usuario y este permite que sea visible, se escribe
           // email en el ldap
           if( ($csr_type == "usr") && ($csr_showMail == "TRUE") )
              $info1["mail"]=$csr_mail;
           else
              $info1["mail"]="none";
*/	   

    	   // Guardamos la informacion de la CSR	
	   $r=ldap_add_info($dn, $info1);
	      
	   if (!$r){
              $errorNumber = 69;
	      $errorCounter ++;
	   }

	   // Incrementamos el contador del numero de certificados del usuario	
	   $r = incrCounter ($copaUsr);
	
	   if (!$r){
              $errorNumber = 69;
	      $errorCounter ++;
           }
							     
  	   if ($errorCounter == 0 ) {
  	      // y le enviamos al administrador un email para avisarle de que tiene una nueva CSR
	      $envioMail = mail($admRaMail, "Nueva CSR", "Se ha creado una nueva CSR con identificador: $cn\n");

	      echo "<h3> Solicitud Aceptada </h3>
	      <p> Su solicitud: </p>
	      <ul>
	      <li> Identificador: $csr_ID </li>
	      <li> C&oacute;digo de soliciud: $copa </li>
	      </ul>
	      <p> ha sido aceptada. </p>
	      <p> Por favor es muy importante que anote los valores anteriores ya que le serán de utilidad a la hora de las siguientes operaciones:</p>
	      <ul> 
	      <li> Autenticación frente a la autoridad de registro. </li>
	      <li> Descarga de su certificado. </li>
	      <li> Revocaci&oacute;n de su certificado. </li>
	      </ul>\n";
	   }
	   else {
              echo "<h3> Error en la Solicitud de Certificado </h3>
              <p> No ha sido posible generar su solicitud</p>\n";
	      $errorNumber = 69;
           }	     
	}
        else {
           echo "<h3> Error en la Solicitud de Certificado </h3>
           <p> No ha sido posible generar su solicitud</p>\n";
	   $errorNumber = 69;
	}		    

        // Registramos la accion en el fichero de log
        $user = "Publico";
        writeLog ($status, $copa, $user, $errorNumber);
   	      
	break;
}

pie ();

?>

